/*
{
    "author": "Your Name",
    "color": "#ffffff",
    "movement": true,
    "parameters": [
        {
            "default": 0.5,
            "name": "brightness"
        },
        {
            "default": 0.5,
            "max": 1.0,
            "min": 0.0,
            "name": "grain"
        },
        {
            "default": 0.5,
            "max": 2.0,
            "min": 0.1,
            "name": "zoom"
        },
        {
            "default": 0.5,
            "max": 10.0,
            "min": 0.1,
            "name": "speed"
        }
    ],
    "url": "",
    "uuid": "d7952e6a-671d-4d4a-9afd-da62d3c3f1cb"
}
*/

#ifdef GL_ES
precision highp float;
#endif

#define PI_F 3.14159265359

float Hash( vec2 p, in float s )
{
    return fract(sin(dot(vec3(p.xy,10.0 * abs(sin(s))),vec3(27.1,61.7, 12.4)))*273758.5453123);
}

float noise(in vec2 p, in float s)
{
    vec2 i = floor(p);
    vec2 f = fract(p);
    return mix(mix(Hash(i + vec2(0.,0.), s), Hash(i + vec2(1.,0.), s),f.x),
    mix(Hash(i + vec2(0.,1.), s), Hash(i + vec2(1.,1.), s),f.x),f.y) * s;
}

void main() {
    vec2 uv = texCoord.xy;

    // Apply zoom parameter
    uv *= vec2(zoom);

    // Time-based movement with speed control
    float time = time * 0.2 * speed;
    uv += vec2(sin(time), cos(time)) * 0.1;

    float scale = 10.0;
    float noiseVal = noise(uv * scale, time);
    float mappedNoise = (noiseVal + 1.0) * 0.5;
    mappedNoise *= grain; // Intensify noise based on grain parameter
    vec3 color = vec3(mappedNoise * brightness);

    gl_FragColor = vec4(color, 1.0);
}